package com.so.net.example;

import com.so.net.DeviceApi.*;
import static com.so.net.DeviceApi.*;
import com.so.net.SignApi;
import static com.so.net.SignApi.Pdf.*;
import static com.so.net.example.Common.*;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;

public class SignAPdfWithPad {

	public static void main(String[] args) throws Exception {
		// This requires
		// .NET5 with hostfxr,
		// libgdiplus on Linux and MacOS,
		// the PDF service,
		// and the native SignAPI.
		SignApi.load();

		// To connect to a pad on the remote computer "ThinClient"
		// Communication.useTCP(java.net.InetAddress.getByName("ThinClient"), 8888);
		// Search for signature device.
		final List<Device.Name> devices = enumerateDevices(Filter.StepOver);
		// Select the first device.
		Device.Name firstDevice = devices.get(0);
		setDevice(firstDevice);

		// Loads a PDF document from the file system.
		byte[] theDocument = Files.readAllBytes(Paths.get("TheDocument.pdf"));
		loadPdf(theDocument);

		// Performs an example signature with hardcoded
		// signature field position, signer info and signing behaviour.
		exampleSign();

		// Download and save the signed document.
		byte[] signedDocument = downloadPdf();
		Files.write(Paths.get("SignedDocument.pdf"), signedDocument);

		// Frees unmanaged resources.
		close();
	}
}
